/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Oculta los conectores que no pertenecen realmente al diagrama, es
decir todos las conexiones entre componentes y paquetes que corresponden
a otros diagramas.
- ENGLISH -
Hides connectors that doesn't belog to the diagram.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.ABLaUML.FUWorker.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.

CLASS com.nomadesoft.ABLaUML.HideDiagramConnsWorker INHERITS FUWorker:
  DEFINE PRIVATE VARIABLE cchFUName AS CHARACTER NO-UNDO.

  DEFINE PRIVATE VARIABLE cchObjectsID AS CHARACTER   NO-UNDO.
  DEFINE PROTECTED PROPERTY cinObjectID AS INTEGER NO-UNDO
    GET():
      IF cchObjectsID EQ '' THEN
        RETURN ?.
      RETURN INTEGER(ENTRY(NUM-ENTRIES(cchObjectsID),cchObjectsID)).
    END GET.
    SET(INPUT ipinObjectID AS INTEGER):
      IF ipinObjectID EQ ? THEN DO:
        IF NUM-ENTRIES(cchObjectsID) LT 2 THEN
          cchObjectsID = ''.
        ELSE
          cchObjectsID = SUBSTRING(cchObjectsID,1,R-INDEX(cchObjectsID,',') - 1).
      END.
      ELSE DO:
        IF cchObjectsID EQ '' THEN
          cchObjectsID = STRING(ipinObjectID).
        ELSE
          cchObjectsID = cchObjectsID + ',' + STRING(ipinObjectID).
      END.
    END SET.

  METHOD PROTECTED OVERRIDE VOID FunctionalUnitStart():
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
    DEFINE VARIABLE minDiagramID AS INTEGER     NO-UNDO.
    DEFINE VARIABLE mchName AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchPackName AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchType AS CHARACTER INITIAL 'nsInitialProgram'  NO-UNDO.

    ASSIGN
      mchPackName = cobParser:attributeValue("path")
      mchName = cobParser:AttributeValue("program")
      .

    minObjectID = cobUtils:FindPackage (
          input mchPackName,
          input cinProjectComponentsPackageId
          ).
    if  minObjectID eq ? or minObjectID eq 0 THEN /* no est la unidad ? */
      RETURN.
    /* encontrar el diagrama para le unidad funcional */
    minDiagramID = cobUtils:FindDiagram(
        INPUT minObjectID,
        INPUT mchPackName
        ).
    IF minDiagramID EQ ? THEN
      RETURN.
    cchFUNAme = mchPackName.
    assign
      cinCurrentObjectID = minDiagramID
      cinCurrentPackageID = minObjectID
      mchType = 'nsInclude' WHEN (mchName EQ ? OR mchName EQ '')
      mchName = cobParser:AttributeValue('include') WHEN (mchName EQ ? OR mchName EQ '')
      .
    minObjectID = cobUtils:FindObject(
      input "Component",
      input mchType,
      input mchName,
      cinCurrentPackageID
      ).
    cobUtils:HideDiagramRelations(
        INPUT minDiagramID,
        INPUT minObjectID
        ).
    cinObjectID = minObjectID.
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID IncludeStart():
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
          
    IF cinCurrentObjectID  EQ ? OR cinCurrentObjectID EQ 0 THEN
      RETURN.
    minObjectID = cobUtils:FindObject (
                input "Component",
                input "nsInclude",
                input cobParser:AttributeValue("file"),
                cinCurrentPackageID
                ).                  
    if     minObjectID eq ?
        or minObjectID eq 0
    THEN DO:
      cinObjectID = -1.
      RETURN.
    END.
    cobUtils:HideDiagramRelations(
        INPUT cinCurrentObjectID,
        INPUT minObjectID
        ).
    cobUtils:ShowDiagramConnector(cinCurrentObjectID,cinObjectID,minObjectID,cchFUName).
    cinObjectID = minObjectID.
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID ProgramStart():
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
          
    IF cinCurrentObjectID EQ ? OR cinCurrentObjectID EQ 0 THEN
      RETURN.
    minObjectID = cobUtils:FindObject (
                input "Component",
                input "nsProgram",
                input cobParser:AttributeValue("file"),
                cinCurrentPackageID
                ).                  
    if     minObjectID eq ?
        or minObjectID eq 0
    THEN DO:
      cinObjectID = -1.
      RETURN.
    END.
    cobUtils:HideDiagramRelations(
        INPUT cinCurrentObjectID,
        INPUT minObjectID
        ).
    cobUtils:ShowDiagramConnector(cinCurrentObjectID,cinObjectID,minObjectID,cchFUName).
    cinObjectID = minObjectID.
  END METHOD.
  
  METHOD PROTECTED OVERRIDE VOID CallStart():
    DEFINE VARIABLE mchCalledName AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
        
    IF cinCurrentObjectID EQ ? OR cinCurrentObjectID EQ 0 THEN
      RETURN.
    mchCalledName = cobParser:AttributeValue('component').
    ASSIGN
      mchCalledName = cobParser:AttributeValue("fu") WHEN (mchCalledName EQ ?)
      .
    IF mchCalledName MATCHES  cchClasifMatch THEN DO:
      minObjectID = cobUtils:FindObject(
        input "Component",
        input "nsClasifInclude",
        input mchCalledName,
        cinClasifComponentsPackageId
        ).
      IF minObjectID EQ ? OR minObjectID EQ 0 THEN DO:
        minObjectID = cobUtils:FindObject(
          input "Component",
          input "nsClasifProgram",
          input mchCalledName,
          cinClasifComponentsPackageId
          ).
      END.
    END.
    ELSE IF mchCalledName MATCHES  cchLibMatch THEN DO:
      minObjectID = cobUtils:FindObject(
        input "Component",
        input "nsLibInclude",
        input mchCalledName,
        cinnsLibComponentsPackageId
        ).
      IF minObjectID EQ ? OR minObjectID EQ 0 THEN DO:
        minObjectID = cobUtils:FindObject(
          input "Component",
          input "nsLibProgram",
          input mchCalledName,
          cinnsLibComponentsPackageId
          ).
      END.
    END.
    ELSE DO:
      mchCalledName = cobParser:AttributeValue("fu").
      minObjectID = cobUtils:FindObject (
        input "Package",
        input "nsFunctionalUnit",
        input mchCalledName,
        ?
        ).                  
    END.
    /* es aceptable que falten unidades funcionales */
    if  minObjectID eq ? or minObjectID eq 0 THEN DO:
      cinObjectID = -1.
      RETURN.
    END.
    cobUtils:HideDiagramRelations(
      INPUT cinCurrentObjectID,
      INPUT minObjectID
      ).
    cobUtils:ShowDiagramConnector(cinCurrentObjectID,cinObjectID,minObjectID,cchFUName).
    cinObjectID = minObjectID.
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID TableRefStart():
    DEFINE VARIABLE minObjectId AS INTEGER     NO-UNDO.
    DEFINE VARIABLE mchTableName AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchDBName AS CHARACTER   NO-UNDO.

    IF cinCurrentObjectID EQ ? OR cinCurrentObjectID EQ 0 THEN
      RETURN.
    mchTableName = SplitDBTable(cobParser:AttributeValue("table"),OUTPUT mchDBName).
    minObjectID = cobUtils:FindPackage(
        mchDBName,
        cinDataModelPackageID
        ).
    minObjectID = cobUtils:FindObject (
        input "Class",
        input "nsTable",
        input mchTableName,
        minObjectID
        ).
    if     minObjectID eq ?
        or minObjectID eq 0
    THEN
      RETURN.
    cobUtils:ShowDiagramConnector(cinCurrentObjectID,cinObjectID,minObjectID,cchFUName).
  end METHOD.

  METHOD PROTECTED OVERRIDE VOID FunctionalUnitEnd():
    cinCurrentObjectID = ?.
    cinCurrentPackageID = ?.
    cinObjectID = ?.
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID CallEnd():
    cinObjectID = ?.
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID ProgramEnd():
    cinObjectID = ?.
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID IncludeEnd():
    cinObjectID = ?.
  END METHOD.

  CONSTRUCTOR HideDiagramConnsWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.
end CLASS.
