/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Mueve los paquetes que son hijos de otros paquetes, dentro
del paquete padre.
- ENGLISH -
Moves child packages into parent package.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.ABLaUML.FUWorker.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.

/**
Se encarga de colocar cada unidad funcional (paquete) en el lugar que le corresponde.
**/
CLASS com.nomadesoft.ABLaUML.PackageMoveWorker INHERITS FUWorker:

  METHOD PROTECTED OVERRIDE VOID FunctionalUnitStart():
    DEFINE VARIABLE mchPackage AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchParent AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE minParent AS INTEGER     NO-UNDO.
    DEFINE VARIABLE minNewParent AS INTEGER     NO-UNDO.
    DEFINE VARIABLE minObject AS INTEGER     NO-UNDO.

    assign
        mchPackage = cobParser:AttributeValue("path")
        mchParent = cobParser:AttributeValue("parent")
        .
    IF mchParent EQ ? OR mchParent EQ '' THEN DO:
      cobParser:DoLog(STRING(THIS-OBJECT), SUBSTITUTE("Unidad funcional &1 no tiene padre",mchPackage),"DEBUG").
      RETURN.
    END.

    minNewParent = cobUtils:FindPackage(
        INPUT mchParent,
        ?
        ).
    IF minNewParent EQ 0 THEN DO: /* el paquete no existe */
      cobParser:DoLog(STRING(THIS-OBJECT), SUBSTITUTE("El paquete &1 no existe",mchParent),"WARNING").
      RETURN.
    END.

    minParent = cobUtils:PackageParent(
        INPUT mchPackage
        ).
    IF minParent NE minNewParent THEN
      cobUtils:MovePackage(
          INPUT mchPackage,
          INPUT ?,
          INPUT minNewParent
          ).
    cobParser:DoLog(STRING(THIS-OBJECT), SUBSTITUTE("Unidad funcional &1 movida ",mchPackage),"DEBUG").
    CATCH pError AS Progress.Lang.Error:
      DELETE OBJECT pError. /* ignorar los errores, no son importantes */
    END CATCH.
  END METHOD.

  CONSTRUCTOR PackageMoveWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.
END CLASS.
