/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Procedimiento para conectar una base de datos.
Verifica si el Alias especificado ya est conectado y si no lo est
muestra/pide los datos de conexin y la conecta.
- ENGLISH -
Database connection procedure.
Checks if supplied Alias is connected and if is not then shows/
requests connection data and connects it.
*****************/

PROCEDURE connectDB:
    DEFINE INPUT  PARAMETER ipchAlias AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER ipchDefName AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER ipchDefHost AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER ipinDefPort AS INTEGER     NO-UNDO.

    DEFINE VARIABLE lchDBName AS CHARACTER LABEL "BD"  FORMAT "x(30)" NO-UNDO.
    DEFINE VARIABLE lchDBHost AS CHARACTER LABEL "Host"  FORMAT "x(40)" NO-UNDO.
    DEFINE VARIABLE linDBPort AS INTEGER   LABEL "Port"  FORMAT "99999999" NO-UNDO.

    IF NOT CONNECTED(ipchAlias) THEN DO:
        ASSIGN
           lchDBName = ipchDefName
           lchDBHost = ipchDefHost
           linDBPort = ipinDefPort
        .
        DISPLAY ipchAlias LABEL 'Alias' WITH FRAME a.
        UPDATE lchDBName lchDBHost linDBPort WITH FRAME a.
        CONNECT VALUE(lchDBName) -S value(linDBPort) -N tcp -H value(lchDBHost) -ld VALUE(ipchAlias).
    END.
END PROCEDURE.
